#include <stdio.h>	// printf()
#include <string.h>	// strlen()
#include <ctype.h>	// toupper()
#include <conio.h>	// getche()
#include <math.h>	// sqrt()

#define MAX_LOECHER	20
#define MAX_NACHRICHT	MAX_LOECHER*4+1	// fr jedes Loch 4 Felder + Mittelfeld

// wenn man eine Zahl durch 2 teilt & es gibt einen Rest, dann ist sie ungerade
#define ungerade(x)	(x%2!=0)

typedef struct
	{
	 int Zeile;
	 int Spalte;
	} TLoch;

int Seitenlaenge=0;		// die Seitenlnge der Schablone in Feldern
TLoch Loch[MAX_LOECHER];	// ein Array mit den Koordinaten der Lcher
int Anzahl_Loecher=0;		// die Anzahl der Lcher

// die Nachricht vor dem Ver-/Entschlsselungsvorgang
char Nachricht_vorher[MAX_NACHRICHT+1]="";

// die Nachricht nach dem Ver-/Entschlsselungsvorgang
char Nachricht_nachher[MAX_NACHRICHT+1]="";

void sortiere_Koordinaten()
{
 int i,j;
 TLoch temp;
 int oberstes;

 // alle Lcher der Reihenfolge nach durcharbeiten
 for(i=0;i<Anzahl_Loecher;i++)
 {
  // davon ausgehen, dass das jeweils bearbeitete Loch bereits an seinem
  // richtigen Platz ist, also von den im Array dahinterliegenden Lchern das
  // oberste ist
  oberstes=i;

  // finde von den im Array dahinterliegenden Lchern das Loch, das noch weiter
  // oben liegt: alle Lcher dahinter berprfen, wenn eines gefunden wurde,
  // das weiter oben ist, beide vertauschen
  for(j=i;j<Anzahl_Loecher;j++)
  {
   if(Loch[j].Zeile*Seitenlaenge+Loch[j].Spalte<
	Loch[oberstes].Zeile*Seitenlaenge+Loch[oberstes].Spalte)
		oberstes=j;
  }

  if(oberstes!=i)	// wurde eines gefunden, das noch weiter oben liegt?
  {
   // ja => beide Lcher vertauschen
   temp.Zeile=Loch[i].Zeile;
   temp.Spalte=Loch[i].Spalte;

   Loch[i].Zeile=Loch[oberstes].Zeile;
   Loch[i].Spalte=Loch[oberstes].Spalte;

   Loch[oberstes].Zeile=temp.Zeile;
   Loch[oberstes].Spalte=temp.Spalte;
  }

 }
}

void drehe_Koordinate_90_Grad(TLoch *l)
{
 int temp;

 temp=l->Zeile;
 l->Zeile=l->Spalte;
 l->Spalte=Seitenlaenge-temp-1;
}

void lies_Quadrat_ein()
{
 int i=1;
 char Eingabe_String[MAX_NACHRICHT+1]="";

 printf("Gib die zu entschlsselnde Nachricht Zeile fr Zeile ein;\n"
	"drck nach der letzten Zeile einfach nochmal die Eingabetaste:\n");

 do
 {
  printf("%d. Zeile: ",i++);
  gets(Eingabe_String);	// lies die Zeile ein...

  // ...und hng sie an die vorigen Zeilen dran
  strcat(Nachricht_vorher,Eingabe_String);

  // lies solange ein, bis eine leere Zeile eingegeben wird
 }while(strlen(Eingabe_String)>0);
}

void gib_Quadrat_aus(int Laenge)
{
 int i,j;

 for(i=0;i<Laenge;i++)		// fr jede Zeile der Nachricht...
 {
  // fr jede Spalte der Nachricht einen Buchstaben schreiben
  for(j=0;j<Laenge;j++) putchar(Nachricht_nachher[i*Laenge+j]);
  // am Ende der Zeile einen Zeilenumbruch
  putchar('\n');
 }
}

// Hauptprogramm
int main()
{
 int nutzbare_Felder=0;
 char Eingabe='v';	// nur f. Eingabe, ob ver- oder entschlsselt werden soll
 int Nachricht_verschluesseln=1;	// verschlsseln oder entschlsseln ?
 int i,j;		// Schleifenzhlvariablen

 printf("Soll eine Nachricht (v)erschlsselt oder (e)ntschlsselt werden? ");
 Eingabe=getche();
 if(toupper(Eingabe)=='E') Nachricht_verschluesseln=0;
 printf("\n");

 if(Nachricht_verschluesseln==1)
 {
  printf("Zu verschlsselnde Nachricht:\n");
  gets(Nachricht_vorher);
 }
 else
 {
  lies_Quadrat_ein();
 }

 if(strlen(Nachricht_vorher)>MAX_NACHRICHT)
 {
  printf("Nachricht fr das Programm zu lang.\nBeende das Programm.\n");
  return 1;
 }

 // Seitenlnge = nchstgrere natrliche Zahl als die Wurzel aus
 // der Nachrichtenlnge
 Seitenlaenge=ceil(sqrt(strlen(Nachricht_vorher)));

 // wenn eine Nachricht verschlsselt werden soll und die Nachricht exakt so
 // viele Buchstaben hat, wie eine Schablone mit ungerader Seitenlnge Felder
 // hat, muss die nchstgrere Schablone benutzt werden (s. Text)
 if((Nachricht_verschluesseln==1)&&ungerade(Seitenlaenge)&&
	(strlen(Nachricht_vorher)==Seitenlaenge*Seitenlaenge))
 {
  Seitenlaenge++;
 }

 printf("\nDie Nachricht hat %d Buchstaben => "
	"benutze eine Schablone der Seitenlnge %d.\n",
	strlen(Nachricht_vorher),Seitenlaenge);

 nutzbare_Felder=Seitenlaenge*Seitenlaenge;
 if(ungerade(Seitenlaenge)) nutzbare_Felder--;

 Anzahl_Loecher=nutzbare_Felder/4;

 printf("\nEingabe der %d Lcher im Format Zeile/Spalte (z.B. 2/3):\n",
	Anzahl_Loecher);

 for(i=0;i<Anzahl_Loecher;i++)
 {
  printf("%d. Loch: ",i+1);
  scanf("%d/%d",&Loch[i].Zeile,&Loch[i].Spalte);

  // wenn das Loch auerhalb der Schablone liegt oder, bei ungerader Seiten-
  // lnge, das mittlere Feld als Loch verwendet werden soll, dann Fehlermeldung
  if((Loch[i].Zeile<1)||(Loch[i].Spalte<1)||
	(Loch[i].Zeile>Seitenlaenge)||(Loch[i].Zeile>Seitenlaenge)||
	(ungerade(Seitenlaenge)&&(Loch[i].Zeile==Seitenlaenge/2+1)&&
	(Loch[i].Spalte==Seitenlaenge/2+1)))
  {
   printf("Falsche Eingabe! Da kann kein Loch sein! Nochmal:\n");
   i--;
   continue;
  }

  Loch[i].Zeile--;Loch[i].Spalte--;	// Arrays beginnen bei 0
 }

 sortiere_Koordinaten();

 printf("\n\n");

 // die eingegebene Nachricht mit Leerzeichen auffllen
 if(strlen(Nachricht_vorher)<nutzbare_Felder)
 {
  for(i=strlen(Nachricht_vorher);i<nutzbare_Felder;i++) Nachricht_vorher[i]=' ';
  // am Schluss eine 0 zur Terminierung des Strings
  Nachricht_vorher[nutzbare_Felder]='\x0';
 }

 // den Ausgabestring erstmal auf Leerzeichen setzen
 memset(Nachricht_nachher,' ',Seitenlaenge*Seitenlaenge);
 // am Schluss eine 0 zur Terminierung des Strings
 Nachricht_nachher[Seitenlaenge*Seitenlaenge]='\x0';

 /*********************\
 * Ver-/Entschlsseln: *
 \*********************/
 for(i=0;i<4;i++)	// insgesamt wird die Schablone in 4 Positionen benutzt
 {
  if(Nachricht_verschluesseln==1)	// wenn verschlsselt werden soll
  {
   // die Buchstaben der nicht verschlsselten Nachricht an die durch die Lcher
   // angegebenen Positionen der verschlsselten Nachricht setzen
   for(j=0;j<Anzahl_Loecher;j++)
   {
    Nachricht_nachher[Loch[j].Zeile*Seitenlaenge+Loch[j].Spalte]=
	Nachricht_vorher[i*Anzahl_Loecher+j];
   }

   // Schablone um 90 drehen
   for(j=0;j<Anzahl_Loecher;j++) drehe_Koordinate_90_Grad(&Loch[j]);
   sortiere_Koordinaten();
  }
  else		// wenn entschlsselt werden soll
  {
   // alle Buchstaben der verschlsselten Nachricht unter den Lchern an
   // die entschlsselte Nachricht anhngen
   for(j=0;j<Anzahl_Loecher;j++)
   {
    Nachricht_nachher[i*Anzahl_Loecher+j]=
	Nachricht_vorher[Loch[j].Zeile*Seitenlaenge+Loch[j].Spalte];
   }

   // Schablone um 90 drehen
   for(j=0;j<Anzahl_Loecher;j++) drehe_Koordinate_90_Grad(&Loch[j]);
   sortiere_Koordinaten();
  }
 }

 /**************************\
 * Ausgabe des Ergebnisses: *
 \**************************/
 if(Nachricht_verschluesseln==1)	// wenn verschlsselt wurde
 {
  printf("Verschlsselte Nachricht:\n");
  gib_Quadrat_aus(Seitenlaenge);
 }
 else					// wenn entschlsselt wurde
 {
  printf("Entschlsselte Nachricht: \"%s\"",Nachricht_nachher);
 }

 printf("\n\nTaste...\n");
 getch();

 return 0;
}
